<template>
	<view>
		<view class="status_bar"></view>
		<view class="" style="position: relative;top: 44px;">
			<view style="position: fixed;z-index: 100;">
				<uni-nav-bar @clickLeft="clickLeft" left-icon="back" title="历史数据"></uni-nav-bar>
			</view>
			<view class="shuju_one">
				<view class="shuju_one_title">
					<view :class="titleidnex==index?'title_text_color':'tltle_text'" v-for="(item,index) in titletext"
						:key="index" @click="changeindex(index)">
						{{item}}
					</view>
				</view>
				<view class="canvastishi" v-if="!canvastishiTF && !dataloadingtf">
					暂无数据
				</view>
				<view class="canvastishi" v-if="dataloadingtf">
					<p class="dataloading">加载中</p>
				</view>
				<canvas v-if="canvastishiTF" canvas-id="canvasColumnA" id="canvasColumnA" class="charts"
					@touchstart="touchLineA($event)" @touchmove="moveLineA($event)" @touchend="touchEndLineA($event)"
					disable-scroll=true
					:style="{'width':cWidth*pixelRatio+'px','height':cHeight*pixelRatio+'px', 'transform': 'scale('+(1/pixelRatio)+')','margin-left':-cWidth*(pixelRatio-1)/2+'px','margin-top':-cHeight*(pixelRatio-1)/2+'px'}"></canvas>
			</view>
			<view class="refresh" @click="refresh">
				刷 新
			</view>
			<view class="condition">
				<scroll-view scroll-x="true" class="scroll-X" scroll-top="0">
					<table class="table" v-if="$QueryPermission(265) ||$QueryPermission(304) ||$QueryPermission(313)">
						<tr class="tr">
							<th class="th" v-for="(item,index) in thdata" :key="index" v-if="(!isShowBwc && item.indexOf('保温仓') < 0) || isShowBwc">{{item}}</th>
						</tr>
						<tr class="tr" v-for="(items,indexs) in historylistdata" :key="indexs" v-if="!forbidden">
							<td class="td">{{items.d_h_t.addtime|timeFormat()}}</td>
							<td class="td">{{items.d_h_t.ds==0?"关":"开"}}</td>
							<td class="td">{{items.d_h_t.at}}</td>
							<td class="td">{{items.d_h_t.ah}}</td>
							<td class="td" v-if="isShowBwc">{{items.d_h_t.set_temp}}</td>
							<td class="td" v-if="isShowBwc">{{items.d_h_t.pre_temp}}</td>
							<td class="td">{{items.d_h_t.batStatus==0?"正常":"欠压"}}</td>
							<!-- <td class="td">{{items.d_h_t.rps==0?"正常":"雨控"}}</td> -->
							<td class="td">{{Circulation.work_sta.value[items.d_h_t.work_sta]}}</td>
							<td class="td">{{items.d_h_t.csq}}</td>
							<td class="td">{{items.d_h_t.current}}</td>
							<td class="td">{{items.d_h_t.vbat}}</td>
							<td class="td">{{items.d_h_t.dver}}</td>
						</tr>
						<tr class="tr" v-if="forbidden">
							
							<td class="td" v-for="(item,index) in thdata" :key="index" v-if="(!isShowBwc && item.indexOf('保温仓') < 0) || isShowBwc">暂无数据</td>
						</tr>
					</table>
					<table class="table" v-else>
						<tr class="tr">
							<th class="th" v-for="(item,index) in thdata2" :key="index" v-if="(!isShowBwc && item.indexOf('保温仓') < 0) || isShowBwc">{{item}}</th>
						</tr>
						<tr class="tr" v-for="(items,indexs) in historylistdata" :key="indexs" v-if="!forbidden">
							<td class="td">{{items.d_h_t.addtime|timeFormat()}}</td>
							<td class="td">{{items.d_h_t.ds==0?"关":"开"}}</td>
							<td class="td">{{items.d_h_t.at}}</td>
							<td class="td">{{items.d_h_t.ah}}</td>
							<td class="td" v-if="isShowBwc">{{items.d_h_t.set_temp}}</td>
							<td class="td" v-if="isShowBwc">{{items.d_h_t.pre_temp}}</td>
							<td class="td">{{items.d_h_t.batStatus==0?"正常":"欠压"}}</td>
							<!-- <td class="td">{{items.d_h_t.rps==0?"正常":"雨控"}}</td> -->
							<td class="td">{{Circulation.work_sta.value[items.d_h_t.work_sta]}}</td>
							<td class="td">{{items.d_h_t.dver}}</td>
						</tr>
						<tr class="tr" v-if="forbidden">
							
							<td class="td" v-for="(item,index) in thdata2" :key="index" v-if="(!isShowBwc && item.indexOf('保温仓') < 0) || isShowBwc">暂无数据</td>
						</tr>
					</table>
				</scroll-view>
				<view class="pagenumber">
					<button @click="prev">上一页</button>
					<view class="pagenumber_page">
						第 {{page}} 页
					</view>
					<view class="pagenumber_page">
						共 {{pagesum}} 页
					</view>
					<button @click="next" :disabled="forbidden">下一页</button>
				</view>
			</view>
		</view>
	</view>
</template>

<script>
	import uCharts from '../../../../components/js_sdk/u-charts/u-charts/u-charts.js';
	import Circulation from "../../../../static/js/equipState_dict.json"
	var canvaColumnA = null;
	export default {
		data() {
			return {
				isShowBwc: false,
				styles: {
					// width: "650rpx",
					height: "400rpx"
				},
				d_id: '',
				start_time: "",
				end_time: "",
				historydatas: [],
				titletext: ["24小时", "近一个月", "近半年", "近一年"],
				titleidnex: 0,
				device_id: '',
				page: 1,
				pagesum: 1,
				historylistdata: [],
				thdata: ["上报时间", "设备开关", "环境温度(°C)", "环境湿度(%)", "保温仓设定温度(°C)", "保温仓当前温度(°C)", "电池状态", "工作状态",
					"信号强度", "电流(mA)", "电压(V)", "设备版本"
				],
				thdata2: ["上报时间", "设备开关", "环境温度(°C)", "环境湿度(%)", "保温仓设定温度(°C)", "保温仓当前温度(°C)", "电池状态", "工作状态",
					"设备版本"
				],
				forbidden: false,
				canvastishiTF: false, //暂无数据提示
				dataloadingtf: true, //加载中提示
				cWidth: '400',
				cHeight: '400',
				pixelRatio: 1,
				Circulation:Circulation
			}
		},
		methods: {
			//forecast.worm_lamp.device_polyline_data 历史数据折线图
			// device_type_id          必传（string）                  设备类型  3虫情测报灯 7孢子仪 4智能性诱 2杀虫灯  9糖醋测报灯  10测报灯rtu
			//    d_id                    必传                            设备id
			//    start_time              非必传(string 时间戳)           开始时间    (用于时间搜索)
			//    end_time
			async history() {
				this.dataloadingtf = true
				const res = await this.$myRequest({
					url: '/api/api_gateway?method=forecast.worm_lamp.device_polyline_data',
					data: {
						device_type_id: 7,
						d_id: this.d_id,
						start_time: parseInt(this.start_time / 1000),
						end_time: parseInt(this.end_time / 1000)
					}
				})
				this.dataloadingtf = false
				console.log(res)
				this.historydatas = res
				console.log(this.historydatas)
				if (this.historydatas.length == 0) {
					this.canvastishiTF = false
				} else {
					this.canvastishiTF = true

					var arr1 = []
					var arr2 = []
					var arr3 = []
					var xtitle = []
					for (var i = 0; i < res.length; i++) {
						var times = new Date(res[i].addtime * 1000)
						xtitle.push(times.getMonth() + 1 + "/" + times.getDate() + "-" + times.getHours() + ":" +
							times.getMinutes())
						arr1.push(res[i].temperature == "" ? "0" : res[i].temperature)
						arr2.push(res[i].humidity == "" ? "0" : res[i].humidity)
						if(res[i].others) {
							arr3.push(res[i].others)
						} else {
							if(res[i].others == "") {
								arr3.push(0)
							}
						}
					}
					var obj = [{
						name: '温度',
						data: arr1,
						color: '#00E29D'
					}, {
						name: '湿度',
						data: arr2,
						color: '#6CBBFF'
					}]
					if(arr3.length > 0) {
						obj.push({
						name: '保温仓温度',
						data: arr3,
						color: '#FF3F3F'
					})
					}
					this.showColumn("canvasColumnA", xtitle, obj)
				}
			},
			//forecast.worm_lamp.device_history_data历史数据列表
			async historylist() { 
				const res = await this.$myRequest({
					url: '/api/api_gateway?method=forecast.worm_lamp.device_history_data',
					data: {
						device_type_id: 7,
						device_id: this.device_id,
						start_time: parseInt(this.start_time / 1000),
						end_time: parseInt(this.end_time / 1000),
						page: this.page
					}
				})
				this.historylistdata = res.data
				this.pagesum = Math.ceil(res.counts / 10) || 1
				if (res.data.length == 0) {
					this.forbidden = true
					console.log(res.data.length)
				} else {
					if(res.data[0].d_h_t.set_temp) {
						this.isShowBwc = true
					} else {
						this.isShowBwc = false;
					}
					this.forbidden = false
					console.log(res.data.length)
				}
			},
			changeindex(index) {
				this.titleidnex = index
				var now = new Date()
				this.$forceUpdate()
				if (index == 0) {
					this.start_time = this.end_time - 24 * 60 * 60 * 1000
					this.history()
					this.historylist()
				} else if (index == 1) {
					var oldtime = now.setMonth(now.getMonth() - 1)
					this.start_time = parseInt(oldtime)
					this.history()
					this.historylist()
				} else if (index == 2) {
					var oldtime = now.setMonth(now.getMonth() - 6)
					this.start_time = parseInt(oldtime)
					this.history()
					this.historylist()
				} else if (index == 3) {
					var oldtime = now.setFullYear(now.getFullYear() - 1)
					this.start_time = parseInt(oldtime)
					this.history()
					this.historylist()
				}
			},
			prev() { //上一页
				if (this.page > 1) {
					this.page--
					this.historylist()
				}
			},
			next() { //下一页
				if (this.page < this.pagesum) {
					this.page++
					this.historylist()
				}
			},
			clickLeft() {
				uni.navigateBack({
					delta: 1
				})
			},
			showColumn(id, xtitle, xinfo) {
				var _self = this;
				console.log(_self.cWidth, '_self.cWidth');
				const ctx = uni.createCanvasContext(id, this);
				canvaColumnA = new uCharts({
					context: ctx,
					type: 'line',
					legend: {
						position: "top"
					},
					fontSize: 11,
					background: '#FFFFFF',
					pixelRatio: 1,
					animation: true,
					dataLabel: false,
					categories: xtitle,
					series: xinfo,
					enableScroll: true, //开启图表拖拽功能
					xAxis: {
						disableGrid: true,
						type: 'grid',
						gridType: 'dash',
						itemCount: 4, //x轴单屏显示数据的数量，默认为5个
						scrollShow: true, //新增是否显示滚动条，默认false
						// scrollAlign: 'left', //滚动条初始位置
						scrollBackgroundColor: '#F7F7FF', //默认为 #EFEBEF
						scrollColor: '#DEE7F7', //默认为 #A6A6A6
					},
					yAxis: {},
					width: _self.cWidth * 1,
					height: _self.cHeight * 1,
					extra: {
						line: {
							type: 'curve'
						}
					}
				});
			},
			touchLineA(e) {
				console.log(e)
				canvaColumnA.scrollStart(e);
			},
			moveLineA(e) {
				canvaColumnA.scroll(e);
			},
			touchEndLineA(e) {
				canvaColumnA.scrollEnd(e);
				//下面是toolTip事件，如果滚动后不需要显示，可不填写
				canvaColumnA.showToolTip(e, {
					format: function(item, category) {
						return category + ' ' + item.name + ':' + item.data
					}
				});
			},
			async newdata() {
				const res = await this.$myRequest({
					url: '/api/api_gateway?method=forecast.send_control.get_device_config',
					data: {
						device_type_id: 7,
						d_id: this.d_id,
						control_type: "data"
					}
				})
				if (res) {
					uni.showToast({
						title: '刷新成功',
						duration: 2000,
						icon: "none"
					});
				} else {
					uni.showToast({
						title: '刷新失败',
						duration: 2000,
						icon: "none"
					});
				}
			},
			refresh() { //获取当前时间的数据
				this.newdata()
			},
		},
		onLoad(option) {
			this.d_id = option.d_id
			this.device_id = option.device_id
			this.cWidth = uni.upx2px(650);
			this.cHeight = uni.upx2px(500);
		},
		onShow() {
			this.end_time = +new Date()
			this.start_time = this.end_time - 24 * 60 * 60 * 1000
			setTimeout(() => {
				this.history()
				this.historylist()
			}, 1000)
		},
		onPullDownRefresh() {
			console.log('refresh');
			this.this.historydatas = []
			this.this.historylistdata = []
			this.history()
			this.historylist()
			setTimeout(function() {
				uni.stopPullDownRefresh();
			}, 1000);
		}
	}
</script>

<style lang="scss">
	.shuju_one,
	.shuju_two {
		position: absolute;
		top: 54px;
		width: 90%;
		left: 5%;
		box-shadow: 0 0 10rpx #bcb9ca;
		padding-top: 20rpx;
		height: 550rpx;

		.canvastishi {
			font-size: 32rpx;
			position: absolute;
			top: 50%;
			left: 50%;
			margin-left: -64rpx;
			margin-top: -21rpx;

			.dataloading:after {
				overflow: hidden;
				display: inline-block;
				vertical-align: bottom;
				animation: ellipsis 2s infinite;
				content: "\2026";
			}

			@keyframes ellipsis {
				from {
					width: 2px;
				}

				to {
					width: 15px;
				}
			}
		}

		.shuju_one_title {
			width: 70%;
			margin: 0 auto;
			display: flex;

			.tltle_text {
				width: 25%;
				border: 2rpx solid #B2B2B2;
				color: #57c878;
				text-align: center;
				font-size: 24rpx;
				height: 50rpx;
				line-height: 50rpx;
			}

			.title_text_color {
				width: 25%;
				border: 2rpx solid #57c878;
				background-color: #57c878;
				color: #fff;
				text-align: center;
				font-size: 24rpx;
				height: 50rpx;
				line-height: 50rpx;
			}
		}
	}

	.refresh {
		position: absolute;
		top: 700rpx;
		left: 5%;
		width: 160rpx;
		height: 50rpx;
		background-color: #57c878;
		color: #FFFFFF;
		line-height: 50rpx;
		text-align: center;
	}

	.condition {
		position: absolute;
		top: 770rpx;
		display: flex;
		flex-wrap: wrap;
		width: 90%;
		left: 5%;
		box-shadow: 0 0 10rpx #bcb9ca;
		margin-bottom: 30rpx;

		.scroll-X {
			width: 95%;
			margin: 20rpx auto;

			.table {
				width: 1672px;
			}

			.tr {
				display: flex;
				overflow: hidden;

				.th,
				.td {
					display: inline-block;
					padding: 5rpx;
					width: 300rpx;
					text-align: center;
					height: 52rpx;
					line-height: 52rpx;
					border: 2rpx solid #F1F1F1;
				}

				.th:first-child,
				.td:first-child {
					width: 350rpx;
				}
			}

			.tr:nth-child(2n-1) {
				background-color: #f5fff8;
			}

			.tr:first-child {
				background-color: #57c878;
				color: #fff;
			}
		}

		.pagenumber {
			display: flex;
			margin: 20rpx auto;

			button {
				width: 150rpx;
				height: 50rpx;
				line-height: 50rpx;
				font-size: 26rpx;
				text-align: center;
				background-color: #57c878;
				color: #FFFFFF;
				margin: 0 10rpx;
			}

			.pagenumber_page {
				width: 100rpx;
				height: 50rpx;
				line-height: 50rpx;
				font-size: 26rpx;
				text-align: center;
			}
		}
	}
</style>
